#!/usr/bin/perl

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#   changelog:	
#		2007-10-20	initial release
#		2007-10-20	added avi/mp3-support (encoding)
#		2007-10-20	improved code for command switches	
#				added renaming-support
#		2007-10-28	added support for myvideo & stage6
#		2007-10-29	added support for changing the videopath 
#				fixed some bugs
#		2007-11-03	added support for just printing the downloadlinks
#				realized that the code is really ugly...
#					=> TODO: rewrite the whole thing,	
#						 maybe tomorrow....
#		2007-11-08	added support for de.youtube.com
#		2008-01-30	minor changes to the code, due to youtubes 
#				latest changes....
#		2008-01-31	replaced the old commadlineparser
#		     -		with Getopt::Long
#		2008-02-01	Replaced systemcalls of wget/curl with
#				LWP::UserAgent methods
#
#
#		Beim Auftreten einer Fehlermeldung wie
#		"user@host ~ $ Can't locate LWP/UserAgent.pm in @INC (@INC contains:)..."
#		Muss das Perlmodul LWP/Useragent installiert werden.
#		Bei Debian/Ubuntu sollte ein "apt-get install libwww-perl" reichen
#		Der Weg ber "perl -MCPAN -e shell" ist ebenfalls mglich
#		Eine ltere Version, die noch wget/curl verwendet, ist unter
#		http://home.arcor.de/haui.45/scripts/perl/ydl_youtubedownloader/old/
#		verfgbar.
#

use strict;
use warnings;
use utf8;
use Getopt::Long;
use LWP::UserAgent;
Getopt::Long::Configure ("bundling", "gnu_compat");

$SIG{INT} = \&catcher;		#Catch Ctrl-C and exit

my %INFO = (
	authors => "Haui",
	contact => "haui45\@web.de",
	date	=> "2008-01-31",
	version => "v0.4a",
	license => "GPL",
	name	=> "ydl - youtube downloader",
);

#*************************************************************************
my $videopath = "/my/videopath/";	#IMPORTANT - change to your path!*
#*************************************************************************

my $vidid = "";		#the "url-id"
my $id = "";		#the "magic-id"
my $path = "";		
my $encode = 0;		#Zieldatei frs encodieren
my $source = "";	#Quelldatei
my $name = "";		#neuer Dateiname
my $ua;			#LWP user agent
my %options = (
		rename	=> '0',
		help	=> '0',
		sound	=> '0',
		version	=> '0',
		encode	=> '0',
		print	=> '0',
);

sub catcher() {
	print "SIGINT recieved....exiting\n";
	exit 1;
}
sub checkargs(){
	if ($#ARGV +1 == 0){
		print "Keine Elmente\n";
		exit;
	}
	GetOptions ("rename|r" => \$options{'rename'}, "help|h" => \$options{'help'},
		 "sound|s" => \$options{'sound'}, "version|v" => \$options{'version'}, 
			"encode|e" => \$options{'encode'} , "print" => \$options{'print'},
				 "path|p=s" => \$videopath);

	if ($options{'version'} == 1){
		version();
		$options{'version'} = 0;
		exit 0;
	}
	if ($options{'help'} == 1){
		help();
		$options{'help'} = 0;
		exit 0;
	}
	if ($#ARGV +1 == 0){
		print "No URL specified\n";
		exit;
	}
	if ($videopath =~ m/\/my\/videopath\// or $videopath eq ""){
		print "Please set a proper videopath!\n";
		exit;
	}
	#print "@{[ %options ]}\n";
}



sub choose(){
	my $dec;
	print "\nWichtig: Wurden alles Links in Anführungszeichen gesetzt? -> \"http://www.youtube.com...\"\n";
	print "[y/n]\n";
	$dec = <STDIN>;
	unless ($dec eq "y\n" or $dec eq "yes\n"){
		exit 1;
	}
	$ua = LWP::UserAgent->new();
	$ua->agent('Mozilla/5.0');
	foreach (@ARGV){
		if ($_ =~ m/^http:\/\/(www\.)*youtube\.com\/watch/ || $_ =~ m/http:\/\/de\.youtube\.com\/watch/){ 
			youtube($_);
			next;
		}
		elsif (($_ =~ m/^http:\/\/www\.myvideo\.de\/watch/ || $_ =~ m/^http:\/\/myvideo\.de\/watch/)){
			myvideo($_);
			next;
		}
		elsif (($_ =~ m/^http:\/\/stage6\.divx\.com/ || $_ =~ m/^http:\/\/www\.stage6\.com/)){
			stage6($_);
			next;
		}
		else{
			print "$_: Not a valid Link!\n";
			next;
		}
	}
}

sub youtube(){
		my ($path, $url) = "";
		my $line = "http://youtube.com/get_video?video_id=" ;
		$vidid = shift;
		$vidid =~ s#http://##;
		$vidid =~ s#^de\.##;
		$vidid =~ s#www\.##;
		$vidid =~ s#youtube.com/watch\?v=##;
		$vidid =~ s#\&.*##;
		$path = "$videopath" . "/$vidid" . ".flv";
		
		if ((getpage($_)) != 0){
			print "Fehler beim holen der Seite!\n\n";
			return -1;
		}

		$id =~ s#\n##g;
		$id =~ s/^.*, "t": "//;		#alles vor und inkl. ', "t": "' loeschen
		$id =~ s/", "hl":.*//;		#alles nach und inkl. '", "hl":' loeschen
		$url = $line . $vidid . "\&t=" . $id;	# url zusammenfuegen
		if($options{'print'}){
			print "Downloadlink: $url\n";
			return 0;
		}

		print "Getting file - this may take a while\n";
		if (download($url, $path) != 0){
			printf("Fehler beim holen!\n\n");
			return -1;
		}
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name");
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
	}
sub myvideo(){
		my ($path, $url);
		my @swfargs;
		$vidid = shift;		# Gesamte URl

		if ((getpage($vidid)) != 0){
			print "Fehler beim holen der Seite!\n\n";
			return -1;
		}
			
		my @array = split(/\n/, $id);

		$vidid =~ s#http://##;			#
		$vidid =~ s#www\.##;			# url-id bekommen
		$vidid =~ s#myvideo\.de/watch/##;	# 

		$path = "$videopath" . "/$vidid" . ".flv";

		@swfargs = grep (/myvideo-[0-9]*\.[a-z]*\.llnwd\.net\/.*\/thumbs\/$vidid.*\.jpg/, @array);# extract
										# the serverlink
		unless (defined($swfargs[0])) {
			print "Variabel swfargs undefiniert...stoppe Methode\n\n"; 
			return -1;
		}
		$id=$swfargs[0];
		undef (@array);
		undef (@swfargs);

		$id =~ s#.*id='[a-z]$vidid' src='##;
		$id =~ s#thumbs/$vidid.*\.jpg.*##;
		chomp($id);
		$id = $id . $vidid . ".flv";
		chomp($id);
				
		$url = $id;
		if($options{'print'}){
			print "\n$url\n";
			return 0;
		}
		print "Getting file - this may take a while...\n";
		if (download($url, $path) != 0){
			printf("Fehler beim holen!\n\n");
			return -1;
		}
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name") or die "myvideo rename: Something went wrong. Fix it! :)\n";
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
	}


sub stage6(){
		my ($path, $url);
		$vidid = shift;
		$vidid =~ s#.*video/##;	
		$vidid =~ s#/.*##;
		chomp $vidid;
		$url = "http://video.stage6.com/" . $vidid . "/.divx";
		$path = "$videopath" . "/$vidid" . ".divx";
		if($options{'print'}){
			print "\n$url\n";
			return 0;
		}

		print "Getting file - this may take a while\n";
		if (download($url, $path) != 0){
			printf("Fehler beim holen!\n\n");
			return -1;
		}
		print "\n[***************]Saved file $path [***************]\n\n";

		if($options{'encode'} == 1){
			if (encode("$path") == -1){
				print "Fehler beim kodieren!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if($options{'sound'} == 1){
			if (sound("$path") == -1){
				print "Fehler beim rippen!\n";
				exit 1;
			}
			print "\n[**************] Encoded file $encode [****************]\n\n" unless 
				($options{'rename'} == 1);
		}
		if ($options{'sound'} == 1 || $options{'encode'} == 1 ){
			unlink("$path");
		}
		else{
			if ($options{'rename'} == 1){
				print "\nBitte geben sie einen neuen Dateinamen ein\n";
				$name = <STDIN>;
				chomp($name);
				$name = "$videopath" . "/$name";
				rename("$path", "$name") or die "stage6 rename: Something went wrong. Fix it! :)\n";
				print "\n$path erfolgreich nach $name umbenannt!\n\n";
		}
		$path="";
		}
}

sub download() {
	my ($url, $path) = @_;
	my ($request, $response);
	$request = HTTP::Request->new('HEAD', $url);			#	Filesize
	$response = $ua->request($request);				# 	.
	if ($response->is_success()){					#	.
		if (int($response->header('Content-Length')) == 0){
			print "Filesize 0 byte....stoppe Methode!\n\n";
			return -1;
		}
		print "Filesize: " . int($response->header('Content-Length')/1024) . "kb\n"; #
	}								#	.
	else{								#	.
		print "Error-Code    : ", $response->code() ,    "\n";	#	.
		print "Fehlermeldung:  ", $response->message() , "\n";	#	.
		return -1;						#	.
	}								#	.
	$request = HTTP::Request->new('GET', $url);			#
	$response = $ua->request($request, $path);			# Getting file...
	if ( $response->is_error() ) { 					#	
	       print "Error-Code    : ", $response->code() ,    "\n";	#
		print "Fehlermeldung:  ", $response->message() , "\n";	#
		return 1;						#
	}	
	return 0;
	
}

sub getpage() {
	my $link = shift;

	my ($path, $request, $response, $url) = "";
	$request = HTTP::Request->new('GET', $link);
	$response = $ua->request($request);
	print "Retrieving http-page...\n";
	if ( $response->is_error() ) { 
		print "Error-Code    : ", $response->code() ,    "\n";
		print "Fehlermeldung:  ", $response->message() , "\n";
		return -1;
	}
	else {
		$id = $response->content();
		return 0;
	}

}

sub encode(){
	$source = shift;
	$encode = $source;
	$encode =~ s/\.flv/\.avi/;
	$encode =~ s/\.divx/\.avi/;
	my $command = "mencoder \"$source\" -oac mp3lame -lameopts abr:br=92" .
	" -ovc xvid -xvidencopts bitrate=150 -o \"$encode\"";
	#$command = "ffmpeg -i \"$source\" -f avi -vcodec xvid -acodec mp3  -s 320x240 \"$encode\"";
	system("$command") == 0 or return -1;

	if ($options{'rename'} == 1){
		print "\nBitte geben sie einen neuen Dateinamen ein\n";
		$name = <STDIN>;
		chomp($name);
		$name =~ s/.avi$//;
		$name = "$videopath" . "/$name" . ".avi";
		rename("$encode", "$name") or die "encode rename: Something went wrong. Fix it! :)\n";
		print "\n$encode erfolgreich nach $name umbenannt!\n\n";
	}

}

sub sound(){
	$source = shift;
	$encode = $source;
	$encode =~ s/\.flv/\.mp3/;
	$encode =~ s/\.divx$/\.mp3/;
	system("mplayer -dumpaudio -dumpfile \"$encode\" \"$source\"") == 0
			or return -1;
	if ($options{'rename'} == 1){
		print "\nBitte geben sie einen neuen Dateinamen ein\n";
		$name = <STDIN>;
		chomp($name);
		$name =~ s/.mp3$//;
		$name = "$videopath" . "/$name" . ".mp3";
		rename("$encode", "$name") or die "sound rename: Something went wrong. Fix it!\n";
		print "\n$encode erfolgreich nach $name umbenannt!\n\n";
	}
}



sub help(){
	print "Aufruf: ydl.pl \"link1\" \"link2\" ...\n".

	 "\nWichtig: die Links müssen von Anführungszeichen umschlossen sein!\n".
	 "Benötig LWP::Useragent und ggf. mencoder/mplayer \n".
	 "Kommandozeilenargument:\n".
	 "   -e, --encode \t enkodiert alle Videos ins divx-Format. Benötigt mencoder!\n".
	 "    \t\t\t ydl -e \"http://youtube...\"\n".
	 "   -s, --sound\t\t extrahiere nur die Sounddaten. Benötigt mplayer!\n".
	 "    \t\t\t ydl -s \"http://youtube...\"\n".
	 "   -r, --rename \t benennt alle Dateien um\n" .
	 "   -p, --path PFAD \t ändert den Zielordner auf PFAD\n" . 
	 "       --print \t\t nur Downloadlinks anzeigen\n" . 
	 "   -h, --help   \t Zeig diese Hilfe an\n".
	 "   -v, --version \t Print version.\n";
	
	return;
}
sub version(){
	print "ydl - youtube-downloader version $INFO{'version'} - $INFO{'date'}\n";
	print "Author: $INFO{'authors'}, contact $INFO{'contact'}\n";
	return;
}

checkargs();
choose();

